#ifndef ZOOM_INFO_H
#define ZOOM_INFO_H

#include <stdbool.h>

/*
 * Maintain information for zooming.
 */
typedef struct {
  /*
   * A zoomed region has been selection.
   */
  bool active;
  
  /*
   * Left, right, bottom and top of zoom region in world coordinates.
   */
  double coords[4];
} ZOOM_INFO;

#endif // ZOOM_INFO_H
